/*
	ConnectMore project

	by Walaber

	Helper functions...
*/

#ifndef _HELPERFUNCTIONS_INCLUDED_
#define _HELPERFUNCTIONS_INCLUDED_

#include "Prereqs.h"
#include "3dmath.h"

#include <DarkSDK.h>


namespace Helpers
{

	int getOpenObjNum();
	int getOpenImageNum();
	int getOpenSoundNum();
	int getOpenMusicNum();
	int getOpenMemblockNum();
	int getOpenMeshNum();
	int getOpenSpriteNum();

	// make a matrix from 3 euler angles + position, for passing to newton.
	void makeFloatMatrix( dVector rot, dVector pos, float* matrix );

	// get the length of a vector.
	float dVectorLength( dVector& vec );

	// make a dMatrix from 3 euler angles.
	dMatrix makedMatrixFromEulerPos( dVector Euler, dVector pos );

	dVector CalcSphereSolid( float mass, float radius );
	dVector CalcBoxSolid(float mass, dVector size );


}	// end NAMESPACE Helpers

#endif // _HELPERFUNCTIONS_INCLUDED_