#ifndef _CONNECTMORE_PREREQS_
#define _CONNECTMORE_PREREQS_

#include <map>
#include <vector>
#include <list>
#include <string>
#include "3dmath.h"

// global variables.
const float _GAME_GRAVITY_ = -15.3f;

// global enums
enum BodyType { BT_BALL, BT_FRAME };

// collision pieces that make up the frame object.
enum CollisionPiece { CP_FRAME, CP_FRONT, CP_BACK, CP_PREVIEW, CP_SHOOT, CP_SHOOT_TRIGGER };


enum Colors { C_RED, C_GREEN, C_BLUE, C_YELLOW, C_MAGENTA, C_CYAN, C_WHITE, C_BLACK, C_BROWN, C_WILD, C_BOMB };

enum GameState { GS_LOAD_MENU, GS_MAIN_MENU, GS_START_GAME, GS_INIT_LEVEL, GS_PLAYING, GS_STOP_PLAYING, GS_GAME_LOST, GS_HISCORES };

enum MainMenuItem { MM_TITLE, MM_PLAY_BUT, MM_HISCORE_BUT, MM_QUIT_BUT };

// structures
struct ColorInfo
{
	int mColor;
	int mImgNum;
	int mEnumVal;
};

struct Spout
{
	dVector mPos;
	dVector mVel;
};

struct HiScore
{
	char* name;
	int score;
};


#endif	// _CONNECTMORE_PREREQS_