#include "SFX_KillBall.h"

SFX_KillBall::SFX_KillBall( dVector pos, int objID )
{
	// load the main object.
	mObjNum = Helpers::getOpenObjNum();
	dbCloneObject( mObjNum, objID );

	dbColorObject( mObjNum, dbRgb(255,255,255) );
	dbGhostObjectOn( mObjNum, 1 );

	dbScaleObject( mObjNum, 51.0f, 51.0f, 51.0f );
	dbPositionObject( mObjNum, pos.m_x, pos.m_y, pos.m_z );

	mLifeLeft = 0.5f;
}

SFX_KillBall::~SFX_KillBall()
{
	if (dbObjectExist( mObjNum ))
		dbDeleteObject( mObjNum );
}


void SFX_KillBall::_update( float timeStep )
{
	// scale based on time left.
	mLifeLeft -= timeStep;
	if (mLifeLeft < 0.0) { mLifeLeft = 0.0f; }

	float scale = (1.0f - ((0.5f - mLifeLeft)/0.5f)) * 51.0f;

	dbScaleObject( mObjNum, scale, scale, scale );

}

bool SFX_KillBall::_deleteme()
{
	return (mLifeLeft <= 0.0f);
}