/*
	ConnectMore project

	by Walaber

	CLASS: SFX_Smoke - smoke trail for balls shot by the user.
*/

#ifndef _SFXSMOKE_INCLUDED_
#define _SFXSMOKE_INCLUDED_

#include "Prereqs.h"

#include "SFXManager.h"
#include "HelperFunctions.h"
#include "BasicBall.h"
#include "WorldInfo.h"
#include <DarkSDK.h>

class SFX_Smoke : public SFXManager::SFXObject
{
public:
	// constructor
	SFX_Smoke( float pps, int imgNum );

	// destructor
	~SFX_Smoke();

	// main update function
	void _update( float timeStep );

	// let the manager know when to destroy this object.
	bool _deleteme();



	// individual particle class
	class SmokeParticle
	{
	public:
		SmokeParticle( dVector pos, dVector vel, float spin, float drag, float expansion, float life, int imgNum );

		~SmokeParticle();

		void update( float timeStep );

		float mLife;

	private:
		int mObjNum;
		dVector mPos;
		dVector mVel;
		float mScale;
		float mSpin;
		float mDrag;
		float mExpansion;
	};


	typedef std::list<SmokeParticle*> SmokeParticleList;
	typedef std::list<SmokeParticle*>::iterator SmokeParticleListIterator;


private:
	SmokeParticleList mParticles;

	// are we still adding new particles to the system?
	bool mStillAdding;


	// particles to create per second
	float mPPS;
	float mTimeToNext;

	// base smoke particle image.
	int mImgNum;

};


#endif	// _SFXSMOKE_INCLUDED_