/*
	ConnectMore project

	by Walaber

	CLASS: SkySphere - simple class for the background sphere (actually now a tube).
*/

#ifndef _SKYSPHERE_INCLUDED_
#define _SKYSPHERE_INCLUDED_

#include "Prereqs.h"
#include "HelperFunctions.h"
#include <DarkSDK.h>



class SkySphere
{
public:
	// subclass for a single tube piece.
	class SkyPiece
	{
	public:
		SkyPiece(char* objfile, int imgNum);
		~SkyPiece();

		void setAngle( float angle ) { mAngle = angle; dbRotateObject( mObjNum, mAngle, 0.0f, 0.0f); }
		float getAngle() { return mAngle; }

		int getObjNum() { return mObjNum; }

	private:
		int mObjNum;
		float mAngle;
	};

	// constructor.
	SkySphere( char* objfile, char* imgfile );

	// destructor.
	~SkySphere();


	// rotate / otherwise animate the sphere.
	void update( float timeStep, float rotSpeed );


private:
	typedef std::vector<SkyPiece*> SkyPieceVector;
	typedef std::vector<SkyPiece*>::iterator SkyPieceVectorIterator;

	SkyPieceVector mPieces;

	int mImgNum;

};


#endif	// _SKYSPHERE_INCLUDED_